#include "StdAfx.h"
#include "UIChatElement.h"
#include "CommonFunction.h"
#include "UserImageActor.h"
#include "ChatDlg.h"
#include "ChatMainView.h"
#include "NeMessengerDlg.h"


UIElement::UIElement( CChatItem* pChatItem, IUIElementResouce* pResouce )
{
	//ZeroMemory(m_pImgUser,sizeof(m_pImgUser));
	m_bEnableRetryButton = TRUE;
	m_pChatMainView = NULL;
	m_pChatItem = pChatItem; 
	m_pResouce = pResouce;
	m_bTooltipExists = false;
	m_crTimeText = DEF_CHAT_TIME_TXT_COLOR;
	m_crReSendCount = Color(0xFF,0xFF,0xFF);
	m_crUserNameText = DEF_CHAT_USERNAME_TXT_COLOR;

	m_rlBubbleTimeFont = BUBBLE_TIME_FONT_SIZE;
	m_rlBubbleUserNameFont = BUBBLE_NAME_FONT_SIZE;
	m_bAddToolTip = false;

    CDC* pDC = m_pResouce->GetCurrentWnd()->GetDC();
	if (pDC)
	{
		m_rlPlainTimeFont = DEF_NAME_FONT_HEIGHT;
		m_rlPlainUserNameFont = DEF_NAME_FONT_HEIGHT;
		m_pResouce->GetCurrentWnd()->ReleaseDC(pDC);
	}
	else
	{
		m_rlPlainTimeFont = 9.0f;
		m_rlPlainUserNameFont = 8.25f;
	}

	m_dwFlags = 0;
	m_rcItem.SetRectEmpty();

	//user image load
	//CString strUserId = pChatItem->GetChatItemInfo()->strUserID;
	//CString strUserImagePath = GET_APP()->GetProfileImagePath(strUserId);
 //   
 //   Image imgTemp(strUserImagePath);
	//m_pImgUser[0] = new Bitmap(imgTemp.GetWidth(), imgTemp.GetHeight(), imgTemp.GetPixelFormat());
	//Graphics  graphics(m_pImgUser[0]);
	//
	//graphics.Clear( Color( 255, 255, 255 ) );
	//graphics.DrawImage( &imgTemp, Rect( 0, 0, imgTemp.GetWidth(), imgTemp.GetHeight() ));
	////m_pImgUser[0] = imgTemp->Clone();//new Image(imgTemp);

	//CString strImgPath = _T(""), strImgDir = _T("");
	//strImgDir = GetAppImgDir();
	//strImgPath.Format(_T("%s\\%s"), strImgDir, _T("img_main_chat_list_profile_nor.png"));
	//m_pImgUser[1] = new Image(strImgPath);
	
	m_rcUserImage.SetRectEmpty();
	m_rcUserName.SetRectEmpty();
	m_rcReSendImg.SetRectEmpty();
	m_rcDate.SetRectEmpty();
	m_rcDateText.SetRectEmpty();
	m_rcTime.SetRectEmpty();
	m_rcBubble.SetRectEmpty();

}

CChatMainView *UIElement::GetChatMainView()
{
	return m_pChatMainView;
}

void UIElement::SetChatMainView(CChatMainView * pCharMainView)
{
	m_pChatMainView = pCharMainView;
}

BOOL UIElement::IsContainPoint(const CPoint& point) const
{
	return m_rcItem.PtInRect(point);
}

void UIElement::EnableRetryButton(BOOL bEnable)
{
	m_bEnableRetryButton = bEnable;
}

BOOL UIElement::IsEnableRetryButton()
{
	return m_bEnableRetryButton;
}

void UIElement::DrawChatText(Graphics* pGraph, CString strText, CRect* pRtPS, CRect* pRtText, WCHAR* wszFontName, REAL nFontHeight,
							 Gdiplus::StringFormat &format, Gdiplus::FontStyle style, Color crPen, BOOL bSelected, int nSelStart, int nSelEnd)
{
//	int i =3;

	CRect rtIntersect(0, 0, 0, 0);
	int nDSX = 0, nDSY = 0;

	if ((strText.GetLength() > 0) && (rtIntersect.IntersectRect(pRtPS, pRtText)))
	{
		nDSX = pRtText->left - pRtPS->left;
		nDSY = pRtText->top - pRtPS->top;

		Gdiplus::Font myFont(wszFontName, nFontHeight, style);

		RectF layoutRect((Gdiplus::REAL)nDSX, (Gdiplus::REAL)nDSY, (Gdiplus::REAL)(pRtText->Width()), (Gdiplus::REAL)(pRtText->Height()));

		SolidBrush brush(crPen);

		pGraph->DrawString(strText, strText.GetLength(), &myFont, layoutRect, &format, &brush);

		if (bSelected)
		{
			CharacterRange range = CharacterRange(nSelStart, nSelEnd - nSelStart + 1);
			format.SetMeasurableCharacterRanges(1, &range);

			Region selectedRgn;

			pGraph->MeasureCharacterRanges(strText, -1, &myFont, layoutRect, &format, 1, &selectedRgn);
            SolidBrush solidBrush(DEF_CHAT_MSG_SELECTED_BG_COLOR);
			pGraph->FillRegion(&solidBrush, &selectedRgn);

			brush.SetColor(DEF_CHAT_SELECTED_COLOR);
			pGraph->SetClip(&selectedRgn);
			pGraph->DrawString(strText, strText.GetLength(), &myFont, layoutRect, &format, &brush);
			pGraph->ResetClip();
		}
	}
}

void UIElement::DrawChatText(Graphics* pGraph, CString strText, CRect* pRtPS, CRect* pRtText, WCHAR* wszFontName, REAL nFontHeight,
								   Gdiplus::StringAlignment alignment, Gdiplus::FontStyle style, Color crPen, BOOL bSelected, int nSelStart, int nSelEnd)
{
	//int i =3;

	CRect rtIntersect(0, 0, 0, 0);
	int nDSX = 0, nDSY = 0;

	if ((strText.GetLength() > 0) && (rtIntersect.IntersectRect(pRtPS, pRtText)))
	{
		nDSX = pRtText->left - pRtPS->left;
		nDSY = pRtText->top - pRtPS->top;

		Gdiplus::Font myFont(wszFontName, nFontHeight, style);
		StringFormat format;
		format.SetAlignment(alignment);
		format.SetLineAlignment(alignment);
		RectF layoutRect((Gdiplus::REAL)nDSX, (Gdiplus::REAL)nDSY, (Gdiplus::REAL)(pRtText->Width()), (Gdiplus::REAL)(pRtText->Height()));

		SolidBrush brush(crPen);

		pGraph->DrawString(strText, strText.GetLength(), &myFont, layoutRect, &format, &brush);
			
		if (bSelected)
		{
			CharacterRange range = CharacterRange(nSelStart, nSelEnd - nSelStart + 1);
			format.SetMeasurableCharacterRanges(1, &range);

			Region selectedRgn;

			pGraph->MeasureCharacterRanges(strText, -1, &myFont, layoutRect, &format, 1, &selectedRgn);
			SolidBrush solidBrush(DEF_CHAT_MSG_SELECTED_BG_COLOR);
            pGraph->FillRegion(&solidBrush, &selectedRgn);

			brush.SetColor(DEF_CHAT_SELECTED_COLOR);
			pGraph->SetClip(&selectedRgn);
			pGraph->DrawString(strText, strText.GetLength(), &myFont, layoutRect, &format, &brush);
			pGraph->ResetClip();
		}
	}
}
void UIElement::DrawChatText(Graphics* pGraph, const CString& strDrawText, 
							 CRect* pRtPS, CRect* pRtText,
							 WCHAR* wszFontName, REAL nFontHeight,
							 Gdiplus::StringAlignment alignment, Gdiplus::FontStyle style,
							 Color crPen, LPTextRange pRange, const std::vector<TextRange>& vcRange, BOOL bWrap/* = TRUE*/)
{
	//int i =1;
	CString strText = strDrawText;
	CRect rtIntersect(0, 0, 0, 0);
	int nDSX = 0, nDSY = 0;

	if (false == strText.IsEmpty())
	{


		nDSX = pRtText->left - pRtPS->left;
		nDSY = pRtText->top - pRtPS->top;

		Gdiplus::Font myFont(wszFontName, nFontHeight, style);
		StringFormat format;
		format.SetAlignment(alignment);
		if(!bWrap)
		{
			format.SetFormatFlags(StringFormatFlagsNoWrap);
		}

		RectF layoutRect((Gdiplus::REAL)nDSX, (Gdiplus::REAL)nDSY, (Gdiplus::REAL)(pRtText->Width()), (Gdiplus::REAL)(pRtText->Height()));

		SolidBrush brush(crPen);

		CharacterRange rangeFull = CharacterRange(0, strText.GetLength());
		format.SetMeasurableCharacterRanges(1, &rangeFull);

		pGraph->DrawString(strText, strText.GetLength(), &myFont, layoutRect, &format, &brush);

		int nUrlCount = vcRange.size();

		if (nUrlCount > 0)
		{
			Gdiplus::Font urlFont(wszFontName, nFontHeight, style | FontStyleUnderline);
			CharacterRange *pRange = new CharacterRange[nUrlCount];
			SolidBrush urlBrush(DEF_CHAT_URL_TEXT_COLOR);

			for (int i = 0; i < nUrlCount; i++)
			{
				pRange[i] = CharacterRange(vcRange[i].nStart, vcRange[i].nEnd - vcRange[i].nStart);
			}
			format.SetMeasurableCharacterRanges(nUrlCount, pRange);

			Region *pSelectedRgn = new Region[nUrlCount];

			pGraph->MeasureCharacterRanges(strText, -1, &urlFont, layoutRect, &format, nUrlCount, pSelectedRgn);

			for (int i = 0; i < nUrlCount; i++)
			{
				pGraph->SetClip(&pSelectedRgn[i]);
				//pGraph->TranslateClip(0, 1);
				pGraph->DrawString(strText, strText.GetLength(), &urlFont, layoutRect, &format, &urlBrush);
				pGraph->ResetClip();
			}

			delete [] pSelectedRgn;
			delete [] pRange;
		}

		if (pRange->IsValid())
		{
			int nSelStart = pRange->nStart;
			int nSelEnd = pRange->nEnd;

			CharacterRange range = CharacterRange(nSelStart, nSelEnd - nSelStart + 1);
			format.SetMeasurableCharacterRanges(1, &range);

			Region selectedRgn;

			pGraph->MeasureCharacterRanges(strText, -1, &myFont, layoutRect, &format, 1, &selectedRgn);
			SolidBrush solidBrush(DEF_CHAT_MSG_SELECTED_BG_COLOR);
            pGraph->FillRegion(&solidBrush, &selectedRgn);

			brush.SetColor(DEF_CHAT_SELECTED_COLOR);
			pGraph->SetClip(&selectedRgn);
			pGraph->DrawString(strText, strText.GetLength(), &myFont, layoutRect, &format, &brush);
			pGraph->ResetClip();
		}
	}
}

void UIElement::DrawChatText(Graphics* pGraph, CChatItem* pChItem, const CString& strDrawText, CRect* pRtPS, CRect* pRtText,
						Gdiplus::StringAlignment alignment, Color crPen, LPTextRange pRange, const std::vector<TextRange>& vcRange)
{
	//int i =2;

	CString strText = strDrawText;
	CRect rtIntersect(0, 0, 0, 0);
	int nDSX = 0, nDSY = 0;

	TextRange textAllRange;
	TextRange textNormalRange;
	std::vector<TextRange> vcNormalRange;
	textAllRange.nStart = 0;
	textAllRange.nEnd   = strDrawText.GetLength();
	_GetNormalTextRange(textAllRange, vcRange, &vcNormalRange);

	if (false == strText.IsEmpty())
	{
		WCHAR* wszFontName = pChItem->GetFontFaceName();
		REAL nFontHeight = pChItem->GetFontHeight();
		Gdiplus::FontStyle style = pChItem->GetFontStyle();

		nDSX = pRtText->left - pRtPS->left;
		nDSY = pRtText->top - pRtPS->top;
		
		SolidBrush NormalBrush(crPen);
		Gdiplus::Font NormalFont(wszFontName, nFontHeight, style);

		StringFormat format;
		format.SetAlignment(alignment);
		format.SetLineAlignment(StringAlignmentCenter);
		RectF layoutRect((Gdiplus::REAL)nDSX, (Gdiplus::REAL)nDSY, (Gdiplus::REAL)(pRtText->Width()), (Gdiplus::REAL)(pRtText->Height()));
		
		int nNormalCount = vcNormalRange.size();
		int nUrlCount = vcRange.size();			
		Region *pURLRgn = NULL;

		if(nUrlCount > 0)
		{
			Gdiplus::Font urlFont(wszFontName, nFontHeight, style | FontStyleUnderline);
			CharacterRange *pURLRange = new CharacterRange[nUrlCount];
			SolidBrush urlBrush(DEF_CHAT_URL_TEXT_COLOR);

			for (int i = 0; i < nUrlCount; i++)
			{
				pURLRange[i] = CharacterRange(vcRange[i].nStart, vcRange[i].nEnd - vcRange[i].nStart);
			}
			format.SetMeasurableCharacterRanges(nUrlCount, pURLRange);

			Region *pURLRgn = new Region[nUrlCount];

			pGraph->MeasureCharacterRanges(strText, -1, &urlFont, layoutRect, &format, nUrlCount, pURLRgn);

			for (int i = 0; i < nUrlCount; i++)
			{
				pGraph->SetClip(&pURLRgn[i]);
				pGraph->DrawString(strText, strText.GetLength(), &urlFont, layoutRect, &format, &urlBrush);
				pGraph->ResetClip();
			}

			pGraph->SetClip(layoutRect);

			if(nNormalCount > 0)
			{
				for (int i = 0; i < nUrlCount; i++)
				{
					pGraph->ExcludeClip(&pURLRgn[i]);
				}

				pGraph->DrawString(strText, strText.GetLength(), &NormalFont, layoutRect, &format, &NormalBrush);
			}
			
			pGraph->ResetClip();

			delete [] pURLRgn;
			delete [] pURLRange;
		}
		else
		{
			pGraph->DrawString(strText, strText.GetLength(), &NormalFont, layoutRect, &format, &NormalBrush);
		}
		
		if (pRange && pRange->IsValid())
		{
			int nSelStart = pRange->nStart;
			int nSelEnd = pRange->nEnd;

			CharacterRange range = CharacterRange(nSelStart, nSelEnd - nSelStart + 1);
			format.SetMeasurableCharacterRanges(1, &range);

			Region selectedRgn;

			pGraph->MeasureCharacterRanges(strText, -1, &NormalFont, layoutRect, &format, 1, &selectedRgn);

            SolidBrush solidBrush(DEF_CHAT_MSG_SELECTED_BG_COLOR);
			pGraph->FillRegion(&solidBrush, &selectedRgn);

			NormalBrush.SetColor(DEF_CHAT_SELECTED_COLOR);
			pGraph->SetClip(&selectedRgn);
			pGraph->DrawString(strText, strText.GetLength(), &NormalFont, layoutRect, &format, &NormalBrush);
			pGraph->ResetClip();
		}
	}
}

void UIElement::CalcDateSize( const CPoint& ptPos, CSize& sz )
{
	m_rcDate.left = DEF_ITEM_POS_LEFT_REL_X;
	m_rcDate.top  = DEF_DATE_POS_TOP_REL_Y;
	if (m_pResouce)
	{
		Image* pImageL = m_pResouce->GetImgDateBGImage(0);
		Image* pImageC = m_pResouce->GetImgDateBGImage(1);
		Image* pImageR = m_pResouce->GetImgDateBGImage(2);

		CString strDate = GetDateString();
		
		CRect rcBound(0, 0, 500, 500);
		CSize szDate(0, 0);

		REAL fontHeight = BUBBLE_DATE_FONT_SIZE;
		RecalcTextRect(m_pResouce->GetCurrentWnd(), strDate,
			g_defaultFontFaceName, fontHeight, FontStyleRegular, rcBound, szDate);
		
		if (pImageL && pImageC && pImageR)
		{
			m_rcDate.right = m_rcDate.left + pImageL->GetWidth() + szDate.cx + 12 + pImageR->GetWidth();
			m_rcDate.bottom = m_rcDate.top + pImageL->GetHeight();

			m_rcDateText.left = m_rcDate.left + pImageL->GetWidth() + 6;
			m_rcDateText.top = m_rcDate.top + ((int)pImageL->GetHeight() - szDate.cy) / 2;
			if(m_rcDateText.top < 0)
			{
				ASSERT(FALSE);
			}
			m_rcDateText.right = m_rcDateText.left + szDate.cx;
			m_rcDateText.bottom = m_rcDateText.top + szDate.cy;
		}
	}
	m_rcDate.OffsetRect(ptPos);
	m_rcDateText.OffsetRect(ptPos);

	sz.cx = m_rcDate.Width() + DEF_ITEM_POS_LEFT_REL_X;
	sz.cy = m_rcDate.Height() + DEF_DATE_POS_TOP_REL_Y;
}	

void UIElement::DrawDate( Graphics* graph )
{
	CPoint ptZero(0, 0);
	CPoint ptOffset = ptZero - m_pResouce->GetOffSetPoint();
	CRect rcClient  = m_pResouce->GetViewRect();
	ImageAttributes ImgAttr;
	if (m_dwFlags & DEF_CHAT_MSG_DATE)
	{
		if (m_pResouce)
		{
			Image* pImageL = m_pResouce->GetImgDateBGImage(0);
			Image* pImageC = m_pResouce->GetImgDateBGImage(1);
			Image* pImageR = m_pResouce->GetImgDateBGImage(2);

			CRect rcDate = m_rcDate;
			rcDate.OffsetRect(ptOffset);
		
			CRect rcDateImageL = rcDate;
			rcDateImageL.right = rcDate.left + pImageL->GetWidth();

			CRect rcDateImageC = rcDate;
			rcDateImageC.left = rcDateImageL.right;
			rcDateImageC.right = rcDateImageC.left + 12 + m_rcDateText.Width();

			CRect rcDateImageR = rcDate;
			rcDateImageR.left = rcDateImageC.right;


			InterpolationMode interpolationMode = graph->GetInterpolationMode();
			PixelOffsetMode pixelOffsetMode = graph->GetPixelOffsetMode();
			graph->SetInterpolationMode(InterpolationModeNearestNeighbor);
			graph->SetPixelOffsetMode(PixelOffsetModeHalf);

			DrawImageToDest(graph, pImageL, &rcClient, &rcDateImageL, &ImgAttr);
			DrawImageToDest(graph, pImageC, &rcClient, &rcDateImageC, &ImgAttr);
			DrawImageToDest(graph, pImageR, &rcClient, &rcDateImageR, &ImgAttr);

//			m_rcDateText.OffsetRect(ptOffset);
			CString strDate = GetDateString();
			//DrawTextToDest2(graph, strDate, &rcClient, &m_rcDateText, g_defaultFontFaceName, BUBBLE_DATE_FONT_SIZE, 
			//	StringAlignmentCenter, FontStyleRegular, DEF_CHAT_DATE_TXT_COLOR);

			rcDate.OffsetRect(0,1);
			DrawChatText(graph, strDate, &rcClient, &rcDate, g_defaultFontFaceName, BUBBLE_DATE_FONT_SIZE,
				StringAlignmentCenter, FontStyleRegular, DEF_CHAT_DATE_TXT_COLOR, FALSE, 0, 0);
			
			graph->SetInterpolationMode(interpolationMode);
			graph->SetPixelOffsetMode(pixelOffsetMode);
		}
	}
}

void UIElement::CalcTime( const CPoint& ptPos, CSize& sz, DWORD dwFlag )
{
	m_rcTime.SetRectEmpty();
	if ((dwFlag & DEF_CHAT_MSG_ISMINE) && m_pChatItem->IsFailedMsg())
	{
		sz.cx = 0;
		sz.cy = 0;
		return;
	}

	BOOL bUserName = (BOOL)(dwFlag & DEF_CHAT_MSG_USERNAME);
	if (CHAT_BUBBLE == m_pResouce->GetChatDisplayType())
	{
		CString strTime = GetTimeString();

		CSize szTime(0, 0);
		CRect rtTime(0, 0, 500, 500);
		RecalcTextRect(m_pResouce->GetCurrentWnd(), strTime,
			g_defaultFontFaceName, m_rlBubbleTimeFont, FontStyleRegular, rtTime, szTime);


		if(dwFlag & DEF_CHAT_MSG_ISMINE)
		{
			m_rcTime.right = m_rcBubble.left - BUBBLE_TIME_MARGIN_X;
			m_rcTime.left  = m_rcTime.right - szTime.cx;
		}
		else
		{
			m_rcTime.left  = m_rcBubble.right + BUBBLE_TIME_MARGIN_X;
			m_rcTime.right = m_rcTime.left + szTime.cx;;
		}
		
		m_rcTime.bottom = m_rcBubble.bottom - BUBBLE_TIME_MARGIN_Y;
		m_rcTime.top = m_rcTime.bottom - szTime.cy;

		sz.cx = m_rcTime.Width();
		sz.cy = m_rcTime.Height();
	}
	else if (CHAT_PLAIN == m_pResouce->GetChatDisplayType())
	{
		CString strTime = GetTimeString();
		CRect rcView = m_pResouce->GetViewRect();
		int nSXTime = 0;
		int nSYTime = 0;
		int nCXTime = 0;
		int nCYTime = 0;

		CSize szTime(0, 0);
		CRect rtTime(0, 0, 500, 500);

		RecalcTextRect(m_pResouce->GetCurrentWnd(), strTime,
			g_defaultFontFaceName, m_rlPlainTimeFont, FontStyleRegular, rtTime, szTime);

		nCXTime = szTime.cx;
		nCYTime = szTime.cy;
		nSXTime = rcView.right - PLAIN_TIME_POS_RIGHT_X - szTime.cx;
		nSYTime = m_rcUserName.top;

		m_rcTime.SetRect(nSXTime, nSYTime, nSXTime + nCXTime, nSYTime + nCYTime);
		//m_rcTime.OffsetRect(ptPos);

		sz.cx = m_rcTime.Width();
		sz.cy = m_rcTime.Height();
	}
}

void UIElement::DrawTime( Graphics* graph ,BOOL bNear)
{
	CPoint ptZero(0, 0);
	CPoint ptOffset = ptZero - m_pResouce->GetOffSetPoint();
	if (CHAT_BUBBLE == m_pResouce->GetChatDisplayType())
	{
		CString strTime = GetTimeString();
		CRect rcTime = m_rcTime;
		rcTime.OffsetRect(ptOffset);
		if (bNear)
		{
			rcTime.OffsetRect(-4,0);
		}
		else
		{
			rcTime.OffsetRect(2,0);
		}

        CRect rect = m_pResouce->GetViewRect();
		DrawChatText(graph, strTime, &rect, &rcTime, g_defaultFontFaceName, m_rlBubbleTimeFont,
			(bNear == TRUE) ?StringAlignmentNear:StringAlignmentFar, FontStyleRegular, m_crTimeText, FALSE, 0, 0);
	}
	else if (CHAT_PLAIN == m_pResouce->GetChatDisplayType())
	{
		CString strTime = GetTimeString();
	
		if(!strTime.IsEmpty() && graph != NULL)
		{
			CRect rcTime = m_rcTime;
			rcTime.OffsetRect(ptOffset);
			vector<TextRange> URLVec;
            CRect rect = m_pResouce->GetViewRect();
			DrawChatText(graph , strTime, &rect, &rcTime, g_defaultFontFaceName, m_rlPlainTimeFont,
				StringAlignmentNear, FontStyleRegular, m_crTimeText, m_pChatItem->GetTimeSelectRange(), URLVec);
		}
	}
}

void UIElement::CalcUserImage( const CPoint& ptPos, CSize& sz )
{
	int nSXName = DEF_ITEM_POS_LEFT_REL_X;
	int nSYName = USER_IMAGE_POS_TOP_REL_Y;

	m_rcUserImage.SetRect(nSXName, nSYName, nSXName + _GetUserImageWidth(), nSYName + _GetUserImageHeight());
	m_rcUserImage.OffsetRect(ptPos);

	sz.cy = USER_IMAGE_POS_TOP_REL_Y + m_rcUserImage.Height();
	sz.cx = DEF_ITEM_POS_LEFT_REL_X + m_rcUserImage.Width();
}

void UIElement::DrawUserImage(Graphics* graph)
{
	CPoint ptZero(0, 0);
	CPoint ptOffset = ptZero - m_pResouce->GetOffSetPoint();

	CRect rcUserImage = m_rcUserImage;
	rcUserImage.OffsetRect(ptOffset);

	InterpolationMode interpolationMode = graph->GetInterpolationMode();
	PixelOffsetMode pixelOffsetMode = graph->GetPixelOffsetMode();
	graph->SetInterpolationMode(InterpolationModeNearestNeighbor);
	graph->SetPixelOffsetMode(PixelOffsetModeHalf);


    CString strUserId = m_pChatItem->GetChatItemInfo()->strUserID;
    CString strUserImagePath = GET_APP()->GetProfileImagePath(strUserId);

    Image imgUser(strUserImagePath);
    ASSERT(imgUser.GetWidth() > 0); //must load the image
	graph->DrawImage(&imgUser, rcUserImage.left, 
		rcUserImage.top, rcUserImage.Width(), rcUserImage.Height());

    CString strImgBackground;
    strImgBackground.Format(_T("%s\\%s"), GetAppImgDir(), _T("img_main_chat_list_profile_nor.png"));

    Image imgBackGround(strImgBackground);
    ASSERT(imgBackGround.GetWidth() > 0); //must load the image

	graph->DrawImage(&imgBackGround, rcUserImage.left, 
		rcUserImage.top, rcUserImage.Width(), rcUserImage.Height());

	graph->SetInterpolationMode(interpolationMode);
	graph->SetPixelOffsetMode(pixelOffsetMode);
}

void UIElement::CalcUserName( const CPoint& ptPos, CSize& sz )
{
	if (CHAT_BUBBLE == m_pResouce->GetChatDisplayType())
	{
		int nSXName = BUBBLE_NAME_POS_TOP_REL_X + m_rcUserImage.right;
		int nSYName = BUBBLE_NAME_POS_TOP_REL_Y + m_rcUserImage.top;

		CSize szName(0, 0);
		CRect rtName(0, 0, 500, 500);
		RecalcTextRect(m_pResouce->GetCurrentWnd(), m_pChatItem->GetChatItemInfo()->strUserName, 
			g_defaultFontFaceName, m_rlBubbleUserNameFont, FontStyleBold, rtName, szName);

		m_rcUserName.SetRect(nSXName, nSYName, nSXName + szName.cx + 5, nSYName + szName.cy);
		//m_rcUserName.OffsetRect(ptPos);
		sz.cy = USER_IMAGE_POS_TOP_REL_Y + BUBBLE_NAME_POS_TOP_REL_Y + m_rcUserName.Height();
		sz.cx = nSXName + m_rcUserName.Width();

	}
	else if (CHAT_PLAIN == m_pResouce->GetChatDisplayType())
	{
		int nSXName =  PLAIN_NAME_POS_LEFT_REL_X + m_rcUserImage.right;
		int nSYName =  PLAIN_NAME_POS_TOP_REL_Y + m_rcUserImage.top;

		CSize szName(0, 0);
		CRect rtName(0, 0, 500, 500);

		HDC hDC = m_pResouce->GetCurrentWnd()->GetDC()->m_hDC;
		REAL fontHeight = m_rlPlainUserNameFont;

		RecalcTextRect(m_pResouce->GetCurrentWnd(), 
			m_pChatItem->GetChatItemInfo()->strUserName,
			g_defaultFontFaceName, fontHeight, FontStyleBold,
			rtName, szName);

		::ReleaseDC(m_pResouce->GetCurrentWnd()->m_hWnd, hDC);
		m_rcUserName.SetRect(nSXName, nSYName, nSXName + szName.cx + 10, nSYName + szName.cy);
		//m_rcUserName.OffsetRect(ptPos);
		sz.cy = USER_IMAGE_POS_TOP_REL_Y + PLAIN_NAME_POS_TOP_REL_Y + m_rcUserName.Height();
		sz.cx = PLAIN_NAME_POS_LEFT_REL_X + m_rcUserName.Width();
	}
}

void UIElement::DrawUserName( Graphics* graph )
{
	CWnd* pWnd = m_pResouce->GetCurrentWnd();
	CRect rtPS = m_pResouce->GetViewRect();
	CPoint ptZero(0, 0);
	CPoint ptOffset = ptZero - m_pResouce->GetOffSetPoint();
   
    if (CHAT_BUBBLE == m_pResouce->GetChatDisplayType())
	{
		CRect rcUserName = m_rcUserName;
		rcUserName.OffsetRect(ptOffset);
		REAL fontHeight = DEF_NAME_FONT_HEIGHT;
		DrawChatText(graph, m_pChatItem->GetChatItemInfo()->strUserName, &rtPS, &rcUserName, g_defaultFontFaceName, m_rlBubbleUserNameFont,
			StringAlignmentNear, FontStyleBold, m_crUserNameText, FALSE, 0, 0);
	}
	else if (CHAT_PLAIN == m_pResouce->GetChatDisplayType())
	{
		if(!m_pChatItem->GetChatItemInfo()->strUserName.IsEmpty())
		{
			CRect rcUserName = m_rcUserName;
			rcUserName.OffsetRect(ptOffset);
			LPChatItemInfo pInfo = m_pChatItem->GetChatItemInfo();
			Color crText = CColorConvert::HEX2Color(0x000000);
			
			//crText.SetFromCOLORREF(pInfo->cf.crTextColor);
			vector<TextRange> URLVec;
			DrawChatText(graph, m_pChatItem->GetChatItemInfo()->strUserName, &rtPS, &rcUserName, g_defaultFontFaceName, m_rlPlainUserNameFont,
				StringAlignmentNear, FontStyleBold, crText, m_pChatItem->GetNameSelectRange(), URLVec);
		}
	}
}

CString UIElement::GetTimeString()
{
	CString strTime = _T("");

	LPChatItemInfo pInfo = m_pChatItem->GetChatItemInfo();
	tm tmUTC;
	pInfo->time.GetGmtTm(&tmUTC);
	int nHour = tmUTC.tm_hour;
	int nMinute = tmUTC.tm_min;

	strTime.Format(_T("%02d:%02d"), nHour, nMinute);


	return strTime;
	/*CString strTime = _T("");
	if (CHAT_BUBBLE == m_pResouce->GetChatDisplayType())
	{
		LPChatItemInfo pInfo = m_pChatItem->GetChatItemInfo();
		tm tmUTC;
		pInfo->time.GetGmtTm(&tmUTC);
		int nHour = tmUTC.tm_hour;
		int nMinute = tmUTC.tm_min;

		CString strMeridiem;

		if (nHour >= 12)
		{
			strMeridiem.LoadString(IDS_STRING_PM);
		}
		else
		{
			strMeridiem.LoadString(IDS_STRING_AM);
		}
		CString strFormat = BUBBLE_TIME_FORMAT;
		strTime.Format(strFormat, strMeridiem, (nHour > 12 ? (nHour - 12) : nHour), nMinute);
	}
	else if (CHAT_PLAIN == m_pResouce->GetChatDisplayType())
	{
		CTime time =  m_pChatItem->GetChatItemInfo()->time;
		LPChatItemInfo pInfo = m_pChatItem->GetChatItemInfo();
		tm tmUTC;
		pInfo->time.GetGmtTm(&tmUTC);
		int nHour = tmUTC.tm_hour;
		int nMinute = tmUTC.tm_min;
		int nSecond = tmUTC.tm_sec;

		CString strMeridiem;
		if(nHour >= 12)
		{
			strMeridiem.LoadString(IDS_STRING_PM);
		}
		else
		{
			strMeridiem.LoadString(IDS_STRING_AM);
		}

		strTime.Format(PLAIN_TIME_FORMAT, strMeridiem, (nHour > 12 ? (nHour - 12) : nHour), nMinute, nSecond);
	}
	return strTime;*/
}

CString UIElement::GetDateString()
{
	CString strDate = _T("");
	if (CHAT_BUBBLE == m_pResouce->GetChatDisplayType())
	{
		LPChatItemInfo pInfo = m_pChatItem->GetChatItemInfo();
		
		strDate.Format(_T("%s"), pInfo->time.FormatGmt(_T("%Y.%m.%d")));
	}
	else if (CHAT_PLAIN == m_pResouce->GetChatDisplayType())
	{
	}
	return strDate;
}

void UIElement::DrawRetryStatus(Graphics* graph, CRect rcPS)
{
	if (!m_pChatItem->IsFailedMsg() || rcPS.IsRectEmpty() == TRUE)
	{
		return;
	}

	CRect rcView = m_pResouce->GetViewRect();

	CRect rcReSend = rcPS;
	
	Image* pReSendImage = m_pResouce->GetSendStatusImage(3);
	if (m_pChatItem->IsGroupUserChat() || !IsEnableRetryButton())
	{
		pReSendImage = m_pResouce->GetSendStatusImage(4);
	}

	if (pReSendImage)
	{
		CRect rcImage(rcReSend.left, rcReSend.top,
			rcReSend.left + pReSendImage->GetWidth(),
			rcReSend.top + pReSendImage->GetHeight());

		InterpolationMode interpolationMode = graph->GetInterpolationMode();
		PixelOffsetMode pixelOffsetMode = graph->GetPixelOffsetMode();
		graph->SetInterpolationMode(InterpolationModeNearestNeighbor);
		graph->SetPixelOffsetMode(PixelOffsetModeHalf);

		DrawImageToDest(graph, pReSendImage, &rcView, &rcImage, NULL);

		graph->SetInterpolationMode(interpolationMode);
		graph->SetPixelOffsetMode(pixelOffsetMode);
	}

// 	if (m_pChatItem->IsGroupUserChat())
// 	{		
// 		Image* pReSendImageL = m_pResouce->GetSendStatusImage(0);
// 		Image* pReSendImageC = m_pResouce->GetSendStatusImage(1);
// 		Image* pReSendImageR = m_pResouce->GetSendStatusImage(2);
// 
// 		CRect rcImageL(rcReSend.left, rcReSend.top,
// 			rcReSend.left + pReSendImageL->GetWidth(),
// 			rcReSend.top + pReSendImageL->GetHeight());
// 
// 		CRect rcImageC(rcImageL.right, rcReSend.top,
// 			rcImageL.right + 3,
// 			rcReSend.top + pReSendImageC->GetHeight());
// 
// 		CRect rcImageR(rcImageC.right, rcReSend.top,
// 			rcImageC.right + pReSendImageL->GetWidth(),
// 			rcReSend.top + pReSendImageL->GetHeight());
// 
// 		rcImageL.OffsetRect(0,2);
// 		rcImageC.OffsetRect(0,2);
// 		rcImageR.OffsetRect(0,2);
// 		InterpolationMode interpolationMode = graph->GetInterpolationMode();
// 		PixelOffsetMode pixelOffsetMode = graph->GetPixelOffsetMode();
// 		graph->SetInterpolationMode(InterpolationModeNearestNeighbor);
// 		graph->SetPixelOffsetMode(PixelOffsetModeHalf);
// 
// 		DrawImageToDest(graph, pReSendImageL, &rcView, &rcImageL, NULL);
// 		DrawImageToDest(graph, pReSendImageC, &rcView, &rcImageC, NULL);
// 		DrawImageToDest(graph, pReSendImageR, &rcView, &rcImageR, NULL);
// 		graph->SetInterpolationMode(interpolationMode);
// 		graph->SetPixelOffsetMode(pixelOffsetMode);
// 
// 
// 	}
// 	else
// 	{
// 		Image* pReSendImage = m_pResouce->GetSendStatusImage(3);
// 
// 		if (pReSendImage)
// 		{
// 			CRect rcImage(rcReSend.left, rcReSend.top,
// 				rcReSend.left + pReSendImage->GetWidth(),
// 				rcReSend.top + pReSendImage->GetHeight());
// 
// 			InterpolationMode interpolationMode = graph->GetInterpolationMode();
// 			PixelOffsetMode pixelOffsetMode = graph->GetPixelOffsetMode();
// 			graph->SetInterpolationMode(InterpolationModeNearestNeighbor);
// 			graph->SetPixelOffsetMode(PixelOffsetModeHalf);
// 
// 			DrawImageToDest(graph, pReSendImage, &rcView, &rcImage, NULL);
// 
// 			graph->SetInterpolationMode(interpolationMode);
// 			graph->SetPixelOffsetMode(pixelOffsetMode);
// 		}
// 
// 	}
}


void UIElement::ResetSelectRange()
{
	CChatMsgItem* pMsgItem = dynamic_cast<CChatMsgItem*>(m_pChatItem);
	if(pMsgItem)
	{
		LPTextRange pTextRange = pMsgItem->GetSelectRange();
		pTextRange->Reset();
	}
	
	if(CHAT_PLAIN == m_pResouce->GetChatDisplayType())
	{
	   LPTextRange pTimeTextRange = m_pChatItem->GetTimeSelectRange();
	   LPTextRange pNameTextRange = m_pChatItem->GetNameSelectRange();
	   pTimeTextRange->Reset();
	   pNameTextRange->Reset();
	}

	CChatStickerItem* pStickerItem = dynamic_cast<CChatStickerItem*>(m_pChatItem);
	if(pStickerItem)
	{
		pStickerItem->m_bSelected = FALSE;
	}

}

void UIElement::NormalizePoint( CPoint& ptStart, CPoint& ptEnds )
{
	/*if(ptStart.y > ptEnds.y)
	{
		std::swap(ptStart, ptEnds);
	}
	else if(ptStart.y == ptEnds.y)
	{
		if(ptStart.x > ptEnds.x)
		{
		   std::swap(ptStart, ptEnds);
		}
	}  */

	CRect rect(ptStart,  ptEnds);
	rect.NormalizeRect();
	ptStart = rect.TopLeft();
	ptEnds = rect.BottomRight();


}

void UIElement::_SetSelectedItem( 
									 CPoint ptStart, CPoint ptEnd, BOOL bSelectWord, const CRect& rect,
									 CString str, Gdiplus::Font* font, LPTextRange lpRange)
{

	CString strMsg = str;

	LPTextRange pTextRange = lpRange;

	pTextRange->Reset();
	int nSelStart = -1;
	int nSelEnd = -1;
	int nTop = 0;
	int nBottom = 0;

	nTop = rect.top;
	nBottom = rect.bottom;



	int nMsgLength = strMsg.GetLength();

	if (ptStart.y < nTop)
	{
		if (ptEnd.y <= nTop)
		{
			//Select None, do nothing
		}
		else if(ptEnd.y > nBottom)
		{
			//Select All
			nSelStart = 0;
			nSelEnd = nMsgLength - 1;
		}
		else
		{
			//Select Part
			nSelStart = 0;
			nSelEnd = _GetStringIndexUnderPoint(ptEnd, rect, strMsg, font);
			if (-1 == nSelEnd)
			{
				nSelEnd = nMsgLength - 1;
			}
		}
	}
	else if(ptStart.y < nBottom)
	{
		nSelStart = _GetStringIndexUnderPoint(ptStart, rect, strMsg, font);
		if (-1 == nSelStart)
		{
			nSelStart = 0;
		}
		if (ptEnd.y < nBottom)
		{
			nSelEnd = _GetStringIndexUnderPoint(ptEnd, rect, strMsg, font);
			if (-1 == nSelEnd)
			{
				nSelEnd = nMsgLength - 1;
			}
		}
		else
		{
			//Select All
			nSelEnd = nMsgLength - 1;
		}
	}
	else
	{
		//Select None, do thing
	}

	if (nSelStart > 0 && bSelectWord)
	{
		CString leftString = strMsg.Mid(0, nSelStart);

		int nIndex = leftString.ReverseFind(' ');
		if (-1 >= nIndex)
		{
			nSelStart = 0;
		}
		else
		{
			nSelStart = nIndex + 1;
		}

		nSelEnd = strMsg.Find(' ', nSelStart);
		if (-1 == nSelEnd)
		{
			nSelEnd = nMsgLength - 1;
		}
	}
	pTextRange->nStart = nSelStart;
	pTextRange->nEnd = nSelEnd;

	pTextRange->Normalize();
	//TRACE(TEXT("pTextRange = [%d - %d]\n"), pTextRange->nStart, pTextRange->nEnd);
}


void UIElement::_SetTimeSlectedItem( CPoint ptStart, CPoint ptEnd, BOOL bSelectWord )
{

	Gdiplus::Font font(g_defaultFontFaceName, 
		m_rlPlainTimeFont, FontStyleRegular);

	LPTextRange pTextRange = m_pChatItem->GetTimeSelectRange();
	_SetSelectedItem(ptStart, ptEnd, bSelectWord, m_rcTime, GetTimeString(),
		&font, pTextRange);

	if(ptStart.y < m_rcUserName.top && ptEnd.y > m_rcUserName.bottom)
	{
		return;
	}

	if(m_rcUserName.top < ptStart.y && m_rcUserName.bottom > ptStart.y
		&& max(ptStart.x, ptEnd.x) < m_rcTime.left)
	{
		pTextRange->Reset();
	}


	_CheckUserMessageRange(ptStart, ptEnd, m_pChatItem->GetTimeSelectRange());
}

void UIElement::_SetNameSlectedItem( CPoint ptStart, CPoint ptEnd, BOOL bSelectWord )
{
	Gdiplus::Font font(g_defaultFontFaceName, 
		m_rlPlainUserNameFont, FontStyleBold);

	LPTextRange pTextRange = m_pChatItem->GetNameSelectRange();

	_SetSelectedItem(ptStart, ptEnd, bSelectWord, 
		m_rcUserName,
		m_pChatItem->GetChatItemInfo()->strUserName,
		&font, pTextRange);

	if(ptStart.y < m_rcTime.top && ptEnd.y > m_rcTime.bottom)
	{
		return;
	}

	if(m_rcTime.top < ptStart.y && m_rcTime.bottom > ptStart.y
		&& min(ptStart.x, ptEnd.x) > m_rcUserName.right)
	{
		pTextRange->Reset();
	}
}

void UIElement::_CheckUserMessageRange(CPoint ptStart, CPoint ptEnd, LPTextRange lpRange )
{
	if(CHAT_PLAIN == m_pResouce->GetChatDisplayType())
	{
		/*if(m_vecMsgRects.size() == 0)
		{
			return;
		}*/

		//CRect rcFirstLine = m_vecMsgRects[0];
		//if(rcFirstLine.PtInRect(ptStart))
		//{
			/*if(ptStart.y > m_rcTime.top && ptStart.y < m_rcTime.bottom &&
				ptStart.x < m_rcTime.left &&
				ptEnd.y > m_rcTime.top && ptEnd.y < m_rcTime.bottom &&
				ptEnd.x < m_rcTime.left )*/
		/*if(ptStart.x < m_rcTime.top || ptEnd.y > m_rcTime.bottom)
		{
			return;
		}  */

		if(ptStart.y < m_rcTime.top && ptEnd.y > m_rcTime.bottom)
		{
			return;
		}

		if(m_vecMsgRects.size() > 0)
		{
			CRect rcFirstLine = m_vecMsgRects[0];
			if(rcFirstLine.top < ptStart.y && rcFirstLine.bottom > ptStart.y
				&& ptStart.x > m_rcTime.right)
			{
			   lpRange->Reset();
			}
		}


		//}
		

	}
}

//Image* UIElement::_GetUserImage(int nIndex)
//{
//	if(nIndex > 1)
//		return NULL;
//
//	return m_pImgUser[nIndex];
//}

int UIElement::_GetStringIndexUnderPoint( const CPoint& ptPos, const CRect& rect, CString str, Gdiplus::Font* font )
{
	CChatMsgItem* pMsgItem = dynamic_cast<CChatMsgItem*>(m_pChatItem);

	CString strMsg = str;

	if (strMsg.IsEmpty())
		return -1;

	CDC *pDC = m_pResouce->GetCurrentWnd()->GetDC();

	if (!pDC)
		return -1;

	Graphics graph(pDC->m_hDC);

	Gdiplus::Font* myFont = font;
	StringFormat format;
	format.SetAlignment(StringAlignmentNear);

	RectF layoutRect((Gdiplus::REAL)rect.left, (Gdiplus::REAL)rect.top,
		(Gdiplus::REAL)rect.Width(), (Gdiplus::REAL)rect.Height());

	CharacterRange range = CharacterRange(0, strMsg.GetLength());
	format.SetMeasurableCharacterRanges(1, &range);

	Region selectedRgn;
	graph.MeasureCharacterRanges(strMsg, strMsg.GetLength(), myFont, layoutRect, &format, 1, &selectedRgn);

	if (!selectedRgn.IsVisible(ptPos.x, ptPos.y, &graph))
	{
		m_pResouce->GetCurrentWnd()->ReleaseDC(pDC);
		return -1;
	}

	int nMin = 0;
	int nMax = strMsg.GetLength();
	int nMid = 0;

	while (nMin < nMax)
	{
		nMid = (nMin + nMax) / 2;

		if (nMid == nMin || nMid == nMax)
			break;

		range = CharacterRange(nMin, nMid - nMin);
		format.SetMeasurableCharacterRanges(1, &range);

		graph.MeasureCharacterRanges(strMsg, strMsg.GetLength(), myFont, layoutRect, &format, 1, &selectedRgn);

		if (selectedRgn.IsVisible(ptPos.x, ptPos.y, &graph))
		{
			nMax = nMid;
		}
		else
		{
			nMin = nMid;
		}
	}

	m_pResouce->GetCurrentWnd()->ReleaseDC(pDC);
	return nMid;
}

BOOL UIElement::OnMouseMove( UINT nFlags, CPoint point )
{
	BOOL bHandled = FALSE;
	int nDisplayType = m_pResouce->GetChatDisplayType();
	int nCursor = CURSOR_DEFAULT;
	if(CHAT_PLAIN == nDisplayType)
	{
		if(m_rcTime.PtInRect(point) || m_rcUserName.PtInRect(point))
		{
			bHandled = TRUE;
			nCursor = CURSOR_IBEAM;
		}

		m_pResouce->SetCursor(nCursor);
	}

	if(m_rcUserImage.PtInRect(point))
	{
		bHandled = TRUE;
		nCursor = CURSOR_HAND;
		m_pResouce->SetCursor(nCursor);
	}

	HandleToolTip(nFlags, point, true);

	return bHandled;
}

void  UIElement::PlainNormalizePoint(CPoint& ptStart, CPoint& ptEnds)
{
	for(int i = 0; i < m_vecMsgRects.size(); i++)
	{
		if(m_vecMsgRects[i].PtInRect(ptStart) && 
			m_vecMsgRects[i].PtInRect(ptEnds))
		{
			if(ptStart.x > ptEnds.x)
			{
				std::swap(ptStart, ptEnds);
			}
			return;
		}

	}

	if(ptStart.y > ptEnds.y)
	{
		std::swap(ptEnds, ptStart);
	}
}

UIElement::~UIElement( void )
{
	//SAFE_DELETE(m_pImgUser[0]);
	//SAFE_DELETE(m_pImgUser[1]);
}

UINT UIElement::_GetUserImageWidth()
{
	return 37;
}

UINT UIElement::_GetUserImageHeight()
{
	return 37;
}

void UIElement::OnLButtonDown( UINT nFlags, CPoint point )
{
	CPoint ptZero(0, 0);
	CPoint ptOffset = ptZero - m_pResouce->GetOffSetPoint();
	CRect rcUserImage = m_rcUserImage;
	rcUserImage.OffsetRect(ptOffset);
	point.Offset(ptOffset);

	if(rcUserImage.PtInRect(point))
	{
		RECT rcClient = {0};
		::GetWindowRect(m_pChatMainView->GetChatSafeHwnd(), &rcClient);
		RECT rcAround = {rcUserImage.left + rcClient.left, rcUserImage.top + rcClient.top, rcUserImage.right + rcClient.left, rcUserImage.bottom + rcClient.top};

		GET_MESSENGER_DLG()->GetProfileDlgController()->CreateProfileDlg(m_pChatItem->GetChatItemInfo()->strUserID, rcAround, m_pChatMainView->GetChatSafeHwnd());
	}
}

void UIElement::OnMouseHover( UINT nFlags, CPoint point )
{
	HandleToolTip(nFlags, point);
}

void UIElement::OnMouseLeave()
{
	if(m_bTooltipExists)
	{
		CRect rc = m_rcItem;
		CPoint ptZero(0,0);
		CPoint ptOffset = ptZero - m_pResouce->GetOffSetPoint();
		rc.OffsetRect(ptOffset);
		CRect rcToDraw = m_pResouce->GetViewRect();

		if (rc.bottom < rcToDraw.top || rc.top > rcToDraw.bottom)
		{
			return;
		}
		m_bTooltipExists = false;
		HWND hWndToolTip = m_pChatMainView->GetToolTipWindow();
		TOOLINFO *pToolInfo = m_pChatMainView->GetToolInfo();
		::SendMessage(hWndToolTip, TTM_TRACKACTIVATE, FALSE, (LPARAM) &pToolInfo);
	}
}

BOOL UIElement::HandleToolTip( UINT nFlags, CPoint point,bool bOnlyHandleRemove )
{
	CPoint ptZero(0, 0);
	CPoint ptOffset = ptZero - m_pResouce->GetOffSetPoint();
	CRect rcUserImage = m_rcUserImage;
	CRect rcUserName = m_rcUserName;
	CRect rcReSendImg = m_rcReSendImg;
	rcUserImage.OffsetRect(ptOffset);
	rcUserName.OffsetRect(ptOffset);
	rcReSendImg.OffsetRect(ptOffset);
	point.Offset(ptOffset);

	HWND hWndToolTip = m_pChatMainView->GetToolTipWindow();
	TOOLINFO *pToolInfo = m_pChatMainView->GetToolInfo();


	if(  (rcUserImage.PtInRect(point) || rcUserName.PtInRect(point) || rcReSendImg.PtInRect(point)) 
		&& ::IsWindow(hWndToolTip) && pToolInfo != NULL)
	{
		if(m_bTooltipExists || bOnlyHandleRemove)
		{
			return TRUE;
		}

		CString strToolTip;
		if(rcReSendImg.PtInRect(point))
		{
			if (m_pChatItem->GetUserId().CompareNoCase(m_pChatMainView->GetChatModel()->GetMyID()) == 0)
			{
				if(m_pChatMainView->IsGroupRoom() || !IsEnableRetryButton() 
					|| GetChatItem()->GetChatItemInfo()->eMsgGB == CHAT_MSG_FTP)
				{
					strToolTip = LoadStringFromResource(IDS_STRING_CHAT_TOOLTIP_8_1);
				}
				else
				{
					strToolTip = LoadStringFromResource(IDS_STRING_CHAT_TOOLTIP_8);
				}
			}
		}
		else
		{
			strToolTip = m_pChatItem->GetToolTip();
		}

		if(strToolTip.IsEmpty()) 
		{
			return TRUE;
		}

		m_bTooltipExists = true;
		pToolInfo->cbSize = sizeof(TOOLINFO);
		pToolInfo->uFlags = TTF_IDISHWND;
		pToolInfo->hwnd = m_pChatMainView->GetChatSafeHwnd();
		pToolInfo->uId = (UINT_PTR) m_pChatMainView->GetChatSafeHwnd();
		pToolInfo->hinst = AfxGetInstanceHandle();
		pToolInfo->lpszText = const_cast<LPTSTR>( (LPCTSTR) strToolTip );
		pToolInfo->rect = rcUserImage;

		if(!m_bAddToolTip)
		{
			::SendMessage(hWndToolTip, TTM_ADDTOOL, 0, (LPARAM) pToolInfo);
			m_bAddToolTip = true;
		}

		::SendMessage( hWndToolTip,TTM_SETMAXTIPWIDTH,0, TOOLTIP_MAX_WIDTH);
		::SendMessage(hWndToolTip, TTM_SETTOOLINFO, 0, (LPARAM) pToolInfo);
		::SendMessage(hWndToolTip, TTM_TRACKACTIVATE, TRUE, (LPARAM) pToolInfo);
	}
	else
	{
		if(m_bTooltipExists)
		{
			::SendMessage(hWndToolTip, TTM_TRACKACTIVATE, FALSE, (LPARAM) &pToolInfo);
			m_bTooltipExists = false;
		}

	}

	return TRUE;
}


void UIElement::_GetNormalTextRange(const TextRange& range, 
									const std::vector<TextRange>& URLRange, 
									std::vector<TextRange>* pNormalRanges )
{
	if(!range.IsValid())
	{
		pNormalRanges = NULL;
		return;
	}

	TextRange NormalRange;
	NormalRange.nStart = NormalRange.nEnd = range.nStart;

	for(int index = 0; index < URLRange.size(); index++)
	{
		NormalRange.nEnd = URLRange[index].nStart - 1;

		if(NormalRange.IsValid() && NormalRange.nStart < NormalRange.nEnd)
		{
			pNormalRanges->push_back(NormalRange);
		}
		
		NormalRange.nStart = URLRange[index].nEnd + 1;
	}

	NormalRange.nEnd = range.nEnd;

	if(NormalRange.nStart < NormalRange.nEnd)
	{
		pNormalRanges->push_back(NormalRange);
	}
}
